/*************************************************************************
* COPYRIGHT (C) 1999 - 2003  EDF R&D
* THIS LIBRARY IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
* IT UNDER THE TERMS OF THE GNU LESSER GENERAL PUBLIC LICENSE 
* AS PUBLISHED BY THE FREE SOFTWARE FOUNDATION; 
* EITHER VERSION 2.1 OF THE LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.
*  
* THIS LIBRARY IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
* WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
* MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
* LESSER GENERAL PUBLIC LICENSE FOR MORE DETAILS.
*
* YOU SHOULD HAVE RECEIVED A COPY OF THE GNU LESSER GENERAL PUBLIC LICENSE
* ALONG WITH THIS LIBRARY; IF NOT, WRITE TO THE FREE SOFTWARE FOUNDATION,
* INC., 59 TEMPLE PLACE, SUITE 330, BOSTON, MA 02111-1307 USA
*
*************************************************************************/

#include <med_outils.h>
#include <med.h>
#include <stdlib.h>
#include <string.h>

#ifdef MAJUSCULES
#define nedfcone NOMF(EDFCONE)
#define nedfconl NOMF(EDFCONL)
#define nedfcooe NOMF(EDFCOOE)
#define nedfcool NOMF(EDFCOOL)
#define nedfnema NOMF(EDFNEMA)
#define nedfnome NOMF(EDFNOME)
#define nedfnoml NOMF(EDFNOML)
#define nedfnume NOMF(EDFNUME)
#define nedfnuml NOMF(EDFNUML)
#define nedfpgce NOMF(EDFPGCE)
#define nedfpgcl NOMF(EDFPGCL)
#define nedfpygi NOMF(EDFPYGI)
#define nedfpece NOMF(EDFPECE)
#define nedfpecl NOMF(EDFPECL)
#define nedfpyei NOMF(EDFPYEI)
#define nedficoe NOMF(EDFICOE)
#define nedficol NOMF(EDFICOL)
#define nedfscoe NOMF(EDFSCOE)
#define nedfscol NOMF(EDFSCOL)
#else
#define nedfcone NOMF(edfcone)
#define nedfconl NOMF(edfconl)
#define nedfcooe NOMF(edfcooe)
#define nedfcool NOMF(edfcool)
#define nedfnema NOMF(edfnema)
#define nedfnome NOMF(edfnome)
#define nedfnoml NOMF(edfnoml)
#define nedfnume NOMF(edfnume)
#define nedfnuml NOMF(edfnuml)
#define nedfpgce NOMF(edfpgce)
#define nedfpgcl NOMF(edfpgcl)
#define nedfpygi NOMF(edfpygi)
#define nedfpece NOMF(edfpece)
#define nedfpecl NOMF(edfpecl)
#define nedfpyei NOMF(edfpyei)
#define nedficoe NOMF(edficoe)
#define nedficol NOMF(edficol)
#define nedfscoe NOMF(edfscoe)
#define nedfscol NOMF(edfscol)
#endif

#ifdef PPRO_NT
med_int 
__stdcall EDFCONE(med_int *fid, char *maa, unsigned int bidon,
                  med_int *lon, med_int *mdim, med_int *con,med_int *mode_switch,
		  med_int *nbre, 
	          med_int *type_ent,
                  med_int *type_geo,med_int *type_con )
#else
med_int
nedfcone(med_int *fid, char *maa, med_int *lon,med_int *mdim, 
	 med_int *con, med_int *mode_switch, med_int *nbre, 
	 med_int *type_ent,med_int *type_geo,med_int *type_con)
#endif
{
  char *fn;
  med_int ret;

  fn = _MED2cstring(maa, (int) * lon);
  
  if (!fn)
    return(-1); 
  
  ret = (med_int) MEDconnEcr ((med_idt) *fid,fn,(med_int) *mdim,
			      (med_int *)con,(med_mode_switch) *mode_switch,(med_int)*nbre, 
			      (med_entite_maillage)*type_ent,
			      (med_geometrie_element) *type_geo,
			      (med_connectivite) *type_con);

  _MEDcstringFree(fn); 

  return(ret); 
    
}


#ifdef PPRO_NT
med_int 
__stdcall EDFCONL(med_int *fid, char *maa, unsigned int bidon, 
                  med_int *lon, med_int *mdim, med_int *con, med_int *mode_switch,
		  med_int * pfltabtmp, med_int *psizetmp,
                  med_int *type_ent,med_int *type_geo,
                  med_int *type_con )
#else
med_int 
nedfconl(med_int *fid, char *maa, med_int *lon,med_int *mdim,med_int *con, 
	 med_int *mode_switch,
	 med_int * pfltabtmp, med_int *psizetmp,
	 med_int *type_ent,med_int *type_geo,med_int *type_con )
#endif
{
  char *fn;
  med_int ret;

  fn = _MED2cstring(maa, (int) * lon);
  
  if (!fn)
    return(-1); 

  ret = (med_int) MEDconnLire((med_idt) *fid, fn,(med_int) *mdim,(med_int *) con, 
			      (med_mode_switch) *mode_switch,
			      (med_int *) pfltabtmp, (med_size) *psizetmp,
			      (med_entite_maillage) *type_ent,
			      (med_geometrie_element) *type_geo,
			      (med_connectivite) *type_con); 

  _MEDcstringFree(fn);

  return(ret); 
}


#ifdef PPRO_NT
med_int
__stdcall EDFCOOE(med_int *fid,char *maa,unsigned int bidon1,med_int *lon1,
		  med_int *mdim, med_float * coo,med_int * modcoo, med_int *n, 
	          med_int *type_rep, char *nom, 
                  unsigned int bidon2, med_int *lon2, 
	          char *unit, unsigned int bidon3, med_int *lon3)
#else
med_int
nedfcooe(med_int *fid, char *maa, med_int *lon1, med_int *mdim,
	 med_float* coo,med_int *modcoo, med_int *n, 
	 med_int *type_rep, char *nom, med_int *lon2, 
	 char *unit, med_int *lon3)
#endif
{
  med_int ret;
  char *  fn1, *fn2, *fn3;
  med_repere type_rep_c;

  fn1 = _MED2cstring(maa, (int) * lon1);
  fn2 = _MED1cstring(nom, (int) * lon2,(int) *mdim*MED_TAILLE_PNOM);
  fn3 = _MED1cstring(unit, (int) * lon3,(int) *mdim*MED_TAILLE_PNOM);

  if (!fn1 || !fn2 || !fn3)
    return(-1);

  type_rep_c = (med_repere) *type_rep; 
  ret = (med_int) MEDcoordEcr((med_idt) *fid, fn1, (med_int) *mdim,
			      (med_float *) coo,(med_mode_switch)*modcoo,
			      (med_int) *n,type_rep_c,
			      fn2,fn3);
  _MEDcstringFree(fn1);
  _MEDcstringFree(fn2); 
  _MEDcstringFree(fn3);

  return(ret); 
}



#ifdef PPRO_NT
med_int
__stdcall EDFCOOL(med_int *fid, char *maa, unsigned int bidon1, 
                  med_int *lon1, med_int *mdim, med_float * coo, med_int * modcoo, 
		  med_int *numco, med_int * pfltabtmp, med_int * psize, 
		  med_int *type_rep, char *nom, unsigned int bidon2, char *unit, 
                  unsigned int bidon3)
#else
med_int
nedfcool(med_int *fid, char *maa,med_int *lon1,med_int *mdim,
	 med_float * coo,med_int * modcoo,
	 med_int * numco,med_int * pfltabtmp, med_int * psize, 
	 med_int *type_rep, char *nom, 
         char *unit)
#endif
{
  med_int ret;
  char * fn1,* fs1,* fs2;
  med_repere type_rep_c;
  med_size lpsize;

  lpsize = (med_size) *psize;	

  fn1 = _MED2cstring(maa, (int) * lon1);
  fs1 = (char *) malloc(sizeof(char)*MED_TAILLE_PNOM*(*mdim)+1);
  fs2 = (char *) malloc(sizeof(char)*MED_TAILLE_PNOM*(*mdim)+1);

  if (!(fn1&&fs1&&fs2))
    return(-1);

  ret = (med_int) MEDcoordLire((med_idt) *fid, fn1, (med_int ) *mdim,
			       (med_float *) coo,(med_mode_switch)*modcoo,
			       (med_int) *numco, (med_int *) pfltabtmp, lpsize, 
			       &type_rep_c, fs1, fs2);

  *type_rep = (med_int) type_rep_c;
  strncpy(nom,fs1,MED_TAILLE_PNOM*(*mdim));
  _MEDfstring(nom ,MED_TAILLE_PNOM*(*mdim));
  strncpy(unit,fs2,MED_TAILLE_PNOM*(*mdim));
  _MEDfstring(unit,MED_TAILLE_PNOM*(*mdim));

  _MEDcstringFree(fn1);
  free(fs1);
  free(fs2);

  return(ret); 
}


#ifdef PPRO_NT
int
__stdcall EDFNOME (med_int *fid,char *maa, unsigned int bidon1, med_int *lon1,
                   char *nom, unsigned int bidon2, med_int *lon2, 
                   med_int *n, med_int *type_ent,
                   med_int *type_geo)

#else
med_int
nedfnome(med_int *fid,char *maa,med_int *lon1, char *nom,med_int *lon2, 
	 med_int *n,med_int *type_ent,med_int *type_geo)
#endif
{
  med_int ret;
  char * fn1, *fn2;

  fn1 = _MED2cstring(maa, (int) * lon1);
  fn2 = _MED1cstring(nom, (int) * lon2,(int) *n*MED_TAILLE_PNOM);

  if (!fn1 || !fn2)
    return(-1);

  ret = (med_int) MEDnomEcr((med_idt) *fid, fn1, fn2, (med_int) *n, 
			    (med_entite_maillage) *type_ent,
			    (med_geometrie_element) *type_geo); 

  _MEDcstringFree(fn1);
  _MEDcstringFree(fn2);

  return(ret); 
}

#ifdef PPRO_NT
med_int
__stdcall EDFNOML(med_int *fid,char *maa, unsigned int bidon1, med_int *lon1,
                  char *nom , unsigned int bidon2, med_int *n, 
	          med_int *type_ent, med_int *type_geo)

#else
med_int
nedfnoml(med_int *fid,char *maa,med_int *lon1, char *nom,med_int *n, 
	 med_int *type_ent,med_int *type_geo)
#endif
{
  med_int ret;
  char * fn1,* fs1;

  fn1 = _MED2cstring(maa, (int) * lon1);
  fs1 = (char *) malloc(sizeof(char)*MED_TAILLE_PNOM*(*n)+1);

  if ( !(fn1&&fs1) )
    return(-1);

  ret = (med_int) MEDnomLire((med_idt) *fid, fn1, (char *) fs1, (med_int) *n, 
			     (med_entite_maillage) *type_ent,
			     (med_geometrie_element) *type_geo); 

  strncpy(nom,fs1,MED_TAILLE_PNOM*(*n));
  _MEDfstring(nom,MED_TAILLE_PNOM*(*n));

  _MEDcstringFree(fn1);
  free(fs1);

  return(ret); 
}


#ifdef PPRO_NT
med_int
__stdcall EDFNUME(med_int *fid,char *maa, unsigned int bidon1, med_int *lon1,
                  med_int *num, med_int *n, med_int *type_ent,
                  med_int *type_geo)
#else
med_int
nedfnume(med_int *fid,char *maa, med_int *lon1, med_int *num, med_int *n, 
	 med_int *type_ent,med_int *type_geo)
#endif
{
  med_int ret;
  char * fn1;

  fn1 = _MED2cstring(maa, (int) * lon1);

  if (!fn1 )
    return(-1);

  ret = (med_int) MEDnumEcr((med_idt) *fid, fn1, (med_int *) num, (med_int)*n, 
			    (med_entite_maillage) *type_ent,
			    (med_geometrie_element) *type_geo);

  _MEDcstringFree(fn1);

  return(ret); 
}


#ifdef PPRO_NT
int
__stdcall EDFNUML(med_int *fid,char *maa, unsigned int bidon1, med_int *lon1,
                  med_int *num , med_int *n, med_int *type_ent,
                  med_int *type_geo)
#else
med_int
nedfnuml(med_int *fid,char *maa, med_int *lon1, med_int *num , med_int *n, 
	 med_int *type_ent,med_int *type_geo)
#endif
{
  med_int ret;
  char *fn1;

  fn1 = _MED2cstring(maa, (int) * lon1);

  if (!fn1 )
    return(-1);

  ret = (med_int) MEDnumLire((med_idt) *fid, fn1, (med_int *) num,(med_int)*n, 
			     (med_entite_maillage) *type_ent,
			     (med_geometrie_element) *type_geo); 

  _MEDcstringFree(fn1);

  return(ret);
}

#ifdef PPRO_NT
med_int 
__stdcall EDFNEMA (med_int *fid, char *maa, unsigned int bidon, med_int *lon,
                   med_int *quoi, med_int *typ_ent, med_int *typ_geo,
                   med_int *typ_conn)
#else
med_int 
nedfnema(med_int *fid, char *maa, med_int *lon, med_int *quoi, 
	 med_int *typ_ent, med_int *typ_geo,med_int *typ_conn)
#endif
{
  med_int ret;
  char *fn1;

  fn1 = _MED2cstring(maa, (int) * lon);

  if (!fn1 )
    return(-1);

  ret = (med_int) MEDnEntMaa((med_idt) *fid, fn1, (med_table) *quoi, 
			     (med_entite_maillage) *typ_ent, 
			     (med_geometrie_element) *typ_geo,
			     (med_connectivite) *typ_conn); 

  _MEDcstringFree(fn1);

  return(ret); 
}


#ifdef PPRO_NT
med_int 
__stdcall EDFPGCE(med_int *fid, char *maa, unsigned int bidon,med_int *lon, 
		  med_int *index, med_int *ni, med_int *con,
	          med_int *type_ent,med_int *type_con)
#else
med_int
nedfpgce(med_int *fid, char *maa, med_int *lon,
	 med_int *index, med_int *ni, med_int *con,
	 med_int *type_ent,med_int *type_con)
#endif
{
  char *fn;
  med_int ret;

  fn = _MED2cstring(maa, (int) * lon);
  
  if (!fn)
    return(-1); 
  
  ret = (med_int) MEDpolygoneConnEcr((med_idt) *fid,fn,(med_int *) index,(med_int) *ni,
				     (med_int *)con,(med_entite_maillage)*type_ent,
				     (med_connectivite) *type_con);

  _MEDcstringFree(fn); 

  return(ret); 
}


#ifdef PPRO_NT
med_int 
__stdcall EDFPGCL(med_int *fid, char *maa, unsigned int bidon,med_int *lon, 
		  med_int *index, med_int *ni, med_int *con,
	          med_int *type_ent,med_int *type_con)
#else
med_int
nedfpgcl(med_int *fid, char *maa, med_int *lon,
	 med_int *index, med_int *ni, med_int *con,
	 med_int *type_ent,med_int *type_con)
#endif
{
  char *fn;
  med_int ret;

  fn = _MED2cstring(maa, (int) * lon);
  
  if (!fn)
    return(-1); 

  ret = (med_int) MEDpolygoneConnLire((med_idt) *fid, fn,
				      (med_int *) index,(med_int) *ni,(med_int *) con, 
				      (med_entite_maillage) *type_ent,
				      (med_connectivite) *type_con); 

  _MEDcstringFree(fn);

  return(ret); 
}

#ifdef PPRO_NT
med_int 
__stdcall EDFPYGI(med_int *fid, char *maa, unsigned int bidon,med_int *lon, 
	          med_int *type_ent,med_int *type_con,med_int *consize)
#else
med_int
nedfpygi(med_int *fid, char *maa, med_int *lon,
	 med_int *type_ent,med_int *type_con,med_int *consize)
#endif
{
  char *fn;
  med_int ret;

  fn = _MED2cstring(maa, (int) * lon);
  
  if (!fn)
    return(-1); 

  ret = (med_int) MEDpolygoneInfo((med_idt) *fid, fn,
				  (med_entite_maillage) *type_ent,
				  (med_connectivite) *type_con,
				  (med_int *) consize); 

  _MEDcstringFree(fn);

  return(ret); 
}


#ifdef PPRO_NT
med_int 
__stdcall EDFPECE(med_int *fid, char *maa, unsigned int bidon,med_int *lon, 
		  med_int *indexp, med_int *np,med_int *indexf, med_int *nf, 
		  med_int *con,med_int *type_con)
#else
med_int
nedfpece(med_int *fid, char *maa, med_int *lon,
	 med_int *indexp, med_int *np,med_int *indexf, med_int *nf, 
	 med_int *con,med_int *type_con)
#endif
{
  char *fn;
  med_int ret;

  fn = _MED2cstring(maa, (int) * lon);
  
  if (!fn)
    return(-1); 
  
  ret = (med_int) MEDpolyedreConnEcr((med_idt) *fid,fn,(med_int *)indexp,(med_int) *np,
				     (med_int *)indexf,(med_int) *nf,(med_int *)con,
				     (med_connectivite) *type_con);

  _MEDcstringFree(fn); 

  return(ret); 
}


#ifdef PPRO_NT
med_int 
__stdcall EDFPECL(med_int *fid, char *maa, unsigned int bidon,med_int *lon, 
		  med_int *indexp, med_int *np, 
		  med_int * indexf,med_int *nf,
		  med_int *con,med_int *type_con)
#else
med_int
nedfpecl(med_int *fid, char *maa, med_int *lon,
	 med_int *indexp, med_int *np, 
	 med_int *indexf,med_int *nf,
	 med_int *con,med_int *type_con)
#endif
{
  char *fn;
  med_int ret;

  fn = _MED2cstring(maa, (int) * lon);
  
  if (!fn)
    return(-1); 

  ret = (med_int) MEDpolyedreConnLire((med_idt) *fid, fn,
				      (med_int *) indexp,(med_int) *np,
				      (med_int *) indexf,(med_int) *nf,
				      (med_int *) con, 
				      (med_connectivite) *type_con); 

  _MEDcstringFree(fn);

  return(ret); 
}

#ifdef PPRO_NT
med_int 
__stdcall EDFPYEI(med_int *fid, char *maa, unsigned int bidon,med_int *lon, 
	          med_int *type_con,med_int *nf,med_int *consize)
#else
med_int
nedfpyei(med_int *fid, char *maa, med_int *lon,
	 med_int *type_con,med_int *nf,med_int *consize)
#endif
{
  char *fn;
  med_int ret;

  fn = _MED2cstring(maa, (int) * lon);
  
  if (!fn)
    return(-1); 

  ret = (med_int) MEDpolyedreInfo((med_idt) *fid, fn,
				  (med_connectivite) *type_con,
				  (med_int *) nf,
				  (med_int *) consize); 

  _MEDcstringFree(fn);

  return(ret);  
}


#ifdef PPRO_NT
med_int
__stdcall EDFICOE(med_int *fid,char *maa,unsigned int bidon1,med_int *lon1,
		  med_int *mdim, med_float * indices,med_int *n, 
	          med_int *axe, char *comp, 
                  unsigned int bidon2, med_int *lon2, 
	          char *unit, unsigned int bidon3, med_int *lon3)
#else
med_int
nedficoe(med_int *fid, char *maa, med_int *lon1, med_int *mdim,
	 med_float* indices,med_int *n, 
	 med_int *axe, char *comp, med_int *lon2, 
	 char *unit, med_int *lon3)
#endif
{
  med_int ret;
  char *  fn1, *fn2, *fn3;

  fn1 = _MED2cstring(maa, (int) * lon1);
  fn2 = _MED1cstring(comp, (int) * lon2,(int) *mdim*MED_TAILLE_PNOM);
  fn3 = _MED1cstring(unit, (int) * lon3,(int) *mdim*MED_TAILLE_PNOM);

  if (!fn1 || !fn2 || !fn3)
    return(-1);
 
  ret = (med_int) MEDindicesCoordEcr((med_idt) *fid, fn1, (med_int) *mdim,
				     (med_float *) indices,(med_int) *n,
				     (med_int) *axe,fn2,fn3);

  _MEDcstringFree(fn1);
  _MEDcstringFree(fn2); 
  _MEDcstringFree(fn3);

  return(ret); 
}

#ifdef PPRO_NT
med_int
__stdcall EDFICOL(med_int *fid,char *maa,unsigned int bidon1,med_int *lon1,
		  med_int *mdim, med_float * indices,med_int *n, 
	          med_int *axe, char *comp, 
                  unsigned int bidon2, med_int *lon2, 
	          char *unit, unsigned int bidon3, med_int *lon3)
#else
med_int
nedficol(med_int *fid, char *maa, med_int *lon1, med_int *mdim,
	 med_float* indices,med_int *n, 
	 med_int *axe, char *comp, med_int *lon2, 
	 char *unit, med_int *lon3)
#endif
{
  med_int ret;
  char *  fn1, *fs1, *fs2;

  fn1 = _MED2cstring(maa, (int) * lon1);
  fs1 = (char *) malloc(sizeof(char)*MED_TAILLE_PNOM+1);
  fs2 = (char *) malloc(sizeof(char)*MED_TAILLE_PNOM+1);

  if (!(fn1 && fs1 && fs2))
    return(-1); 
 
  ret = (med_int) MEDindicesCoordLire((med_idt) *fid, fn1, (med_int) *mdim,
				      (med_float *) indices,(med_int) *n,
				      (med_int) *axe,fs1,fs2);

  strncpy(comp,fs1,MED_TAILLE_PNOM);
  _MEDfstring(comp ,MED_TAILLE_PNOM);
  strncpy(unit,fs2,MED_TAILLE_PNOM);
  _MEDfstring(unit,MED_TAILLE_PNOM);

  _MEDcstringFree(fn1);
  free(fs1);
  free(fs2);

  return(ret); 
}

#ifdef PPRO_NT
med_int
__stdcall EDFSCOE(med_int *fid,char *maa, unsigned int bidon1, med_int *lon1,
                  med_int * mdim,med_int *structure)
#else
med_int
nedfscoe(med_int *fid,char *maa, med_int *lon1, med_int *mdim, med_int *structure)
#endif
{
  med_int ret;
  char * fn1;

  fn1 = _MED2cstring(maa, (int) * lon1);

  if (!fn1 )
    return(-1);

  ret = (med_int) MEDstructureCoordEcr((med_idt) *fid, fn1, (med_int) *mdim, (med_int *) structure);

  _MEDcstringFree(fn1);

  return(ret); 
}


#ifdef PPRO_NT
med_int
__stdcall EDFSCOL(med_int *fid,char *maa, unsigned int bidon1, med_int *lon1,
                  med_int *mdim,med_int *structure)
#else
med_int
nedfscol(med_int *fid,char *maa, med_int *lon1, med_int *mdim,med_int *structure)
#endif
{
  med_int ret;
  char * fn1;

  fn1 = _MED2cstring(maa, (int) * lon1);

  if (!fn1 )
    return(-1);

  ret = (med_int) MEDstructureCoordLire((med_idt) *fid, fn1, (med_int) *mdim, (med_int *) structure);

  _MEDcstringFree(fn1);

  return(ret); 
}
