C*************************************************************************
C COPYRIGHT (C) 1999 - 2003  EDF R&D
C THIS LIBRARY IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU LESSER GENERAL PUBLIC LICENSE 
C AS PUBLISHED BY THE FREE SOFTWARE FOUNDATION; 
C EITHER VERSION 2.1 OF THE LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS LIBRARY IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C LESSER GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU LESSER GENERAL PUBLIC LICENSE
C ALONG WITH THIS LIBRARY; IF NOT, WRITE TO THE FREE SOFTWARE FOUNDATION,
C INC., 59 TEMPLE PLACE, SUITE 330, BOSTON, MA 02111-1307 USA
C
C**************************************************************************

c
c     Nom : efouvr
c     Fonction : appelle edfouvr pour ouvrir un fichier
c     In : nom - nom du fichier a ouvrir
c           acces - mode d'acces 1 (lecture), 
c          2 (lecture et ecriture), 3 (lecture et ecriture, 
c          si le fichier existe deja il est detruit)
c     Out : cret 0 reussite, -1 echec
c
      subroutine efouvr(fid, nom, acces, cret)
c
      implicit none
      save
c
      character *(*) nom
      integer acces, fid, cret
      integer edfouvr
c
      fid = edfouvr(nom, acces, len(nom))
      if (fid.eq.-1) then
         cret=-1
      else
         cret=0
      endif
c      
      return
      end
      

      subroutine efferm(fid, cret)
c
      implicit none
      save
c
      integer fid,cret
      integer edfferm
c
      cret = edfferm(fid)
c      
      return
      end
c
c
      subroutine eflfde (fid,lon,cret)
c
      implicit none
      save
c
      integer fid,cret,lon
      integer edflfde
c
      lon = edflfde(fid)
c
      if (lon .lt. 0) then
         cret = -1
      else
         cret = 0
      endif
c
      end
c
c
      subroutine effien (fid,quoi,str,cret)
c
      implicit none
      save
c
      integer fid,quoi,cret
      integer edffien
      character*(*) str
c
      cret = edffien(fid,quoi,str)
c
      end
      
c
c
      subroutine effide (fid,des,cret)
c
      implicit none
      save
      integer fid,cret
      character*(*) des
      integer edffide
c
      cret = edffide(fid,des,len(des))
c
      end

      subroutine effoco (nom,cret)
c
      implicit none
      save
C
      integer cret
      character*(*) nom
      integer edffoco
c
      cret = edffoco(nom,len(nom))
c
      return
      end
c
c
      subroutine efveco (nom,cret)
c
      implicit none
      save
C
      integer cret
      character*(*) nom
      integer edfveco
c
      cret = edfveco(nom,len(nom))
c
      return
      end
c
c
c
      subroutine efveli (fid,maj,min,rel,cret)
c
      implicit none
      save
C
      integer fid, maj, min, rel
      integer cret
      integer edfveli
c
      cret = edfveli(fid,maj,min,rel)
c
      return
      end
c
c
      subroutine efvedo (maj,min,rel,cret)
c
      implicit none
      save
C
      integer maj, min, rel
      integer cret
      integer edfvedo
c
      cret = edfvedo(maj,min,rel)
c
      return
      end


c
c
      subroutine efmont(fid, acces, type, mid, cret)
c
      implicit none
      save
c
      character *(*) acces
      integer mid, fid, type, cret
      integer edfmont
c
      mid = edfmont(fid, acces, len(acces), type)
      if (mid .eq.-1) then
         cret=-1
      else
         cret=0
      endif
c      
      return
      end

c
c
      subroutine efdemo(fid, mid, type, cret)
c
      implicit none
      save
c
      integer mid, fid, type, cret
      integer edfdemo
c
      cret = edfdemo(fid, mid, type)
c      
      return
      end
