/*************************************************************************
* COPYRIGHT (C) 1999 - 2003  EDF R&D
* THIS LIBRARY IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
* IT UNDER THE TERMS OF THE GNU LESSER GENERAL PUBLIC LICENSE 
* AS PUBLISHED BY THE FREE SOFTWARE FOUNDATION; 
* EITHER VERSION 2.1 OF THE LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.
*  
* THIS LIBRARY IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
* WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
* MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
* LESSER GENERAL PUBLIC LICENSE FOR MORE DETAILS.
*
* YOU SHOULD HAVE RECEIVED A COPY OF THE GNU LESSER GENERAL PUBLIC LICENSE
* ALONG WITH THIS LIBRARY; IF NOT, WRITE TO THE FREE SOFTWARE FOUNDATION,
* INC., 59 TEMPLE PLACE, SUITE 330, BOSTON, MA 02111-1307 USA
*
*************************************************************************/

#include <med.h>
#include <med_outils.h>
#include <hdf5.h>

/*
 * - Nom de la fonction : _MEDfichierMonter
 * - Description : Montage d'un fichier HDF externe sur un point de montage
 * - Parametres :
 *     - pid  (IN)    : ID du pere (fichier ou groupe HDF)
 *     - nom (IN)     : le nom du groupe HDF dans lequel on va monter le fichier
 *                      (point de montage)
 *     - fid (IN)     : ID du fichier externe a monter
 * - Resultat : O en cas de succes, -1 sinon
 */ 

extern
med_err _MEDfichierMonter(med_idt pid, const char *nom, med_idt fid)
{
  med_err ret = 0;

  ret = H5Fmount(pid,nom,fid,H5P_DEFAULT);

  return ret;
}
